POJ 3252-Round Numbers

来源:互联网 发布:考研网络培训班 编辑:程序博客网 时间:2024/06/10 11:48

Round Numbers
Time Limit: 2000MS Memory Limit: 65536KTotal Submissions: 14472 Accepted: 5807

Description

The cows, as you know, have no fingers or thumbs and thus are unable to play Scissors, Paper, Stone' (also known as 'Rock, Paper, Scissors', 'Ro, Sham, Bo', and a host of other names) in order to make arbitrary decisions such as who gets to be milked first. They can't even flip a coin because it's so hard to toss using hooves.

They have thus resorted to "round number" matching. The first cow picks an integer less than two billion. The second cow does the same. If the numbers are both "round numbers", the first cow wins,
otherwise the second cow wins.

A positive integer N is said to be a "round number" if the binary representation of N has as many or more zeroes than it has ones. For example, the integer 9, when written in binary form, is 1001. 1001 has two zeroes and two ones; thus, 9 is a round number. The integer 26 is 11010 in binary; since it has two zeroes and three ones, it is not a round number.

Obviously, it takes cows a while to convert numbers to binary, so the winner takes a while to determine. Bessie wants to cheat and thinks she can do that if she knows how many "round numbers" are in a given range.

Help her by writing a program that tells how many round numbers appear in the inclusive range given by the input (1 ≤ Start < Finish ≤ 2,000,000,000).

Input

Line 1: Two space-separated integers, respectively Start and Finish.

Output

Line 1: A single integer that is the count of round numbers in the inclusive range Start..Finish

Sample Input

2 12

Sample Output

6

Source

USACO 2006 November Silver


题意:

让你求出区间[s,t]内这些数字有多少数字它的二进制状态下0的数目大于等于1的数目的


思路:

代码见


代码:

#include<cstdio>#include<cstring>int dp[50][50][50],digit[50],s,t;//dp[i][zero][one]表示位数为i时zero与one已知个数的情况//dfs间接枚举所有情况int dfs(int pos,int zero,int one,int lead,int limit)//limit判断上一位数字是否达到上界,lead有没有1出现{    if(!pos)return zero>=one;    if(!limit&&dp[pos][zero][one]!= -1)        return dp[pos][zero][one];    int up=limit?digit[pos]:1,ans=0;    for(int i=0;i<=up;i++)        ans+=dfs(pos-1,lead?zero+(i==0):0,one+(i==1),lead||i==1,limit&&i==up);    return  limit?ans:dp[pos][zero][one]=ans;}int cal(int n){    int len=0;    while(n)    digit[++len]=n % 2,n>>=1;    return dfs(len,0,0,0,1);}int main(){    memset(dp,-1,sizeof(dp));    scanf("%d%d",&s,&t);    printf("%d\n",cal(t)-cal(s-1));}